
#define DEBUG

// Make sure the map file is also included to run the demo.

var
	const
		// these are the three visibility groups
		RED_MOB = "red"
		GRAY_MOB = "gray"
		SPY = "spy"

mob
	icon_state = "blue mob"

	Login()
		..()

		// The vis object contains the mob's groups and views.
		// Groups are visibility groups that you're a memeber of,
		// views are the groups you can see. The vis object needs
		// to be instantiated for this functionality to be used.
		vis = new(src)

	verb
		red_mobs_show()
			// the vis object's can_see() proc adds a view
			if(vis.can_see(RED_MOB))
				src << "You can now see red mobs."

		red_mobs_hide()
			// the vis object's cant_see() proc removes a view
			if(vis.cant_see(RED_MOB))
				src << "You can no longer see red mobs."

		gray_mobs_show()
			if(vis.can_see(GRAY_MOB))
				src << "You can now see gray mobs."

		gray_mobs_hide()
			if(vis.cant_see(GRAY_MOB))
				src << "You can no longer see gray mobs."

		spies_show()
			if(vis.can_see(SPY))
				src << "You can now see spy mobs."

		spies_hide()
			if(vis.cant_see(SPY))
				src << "You can no longer see spy mobs."

		turn_red()
			icon_state = "red mob"
			vis.is_a(RED_MOB)

		turn_back()
			icon_state = "blue mob"
			vis.is_not_a(RED_MOB)

	red
		icon_state = "red mob"

		New()
			..()
			vis = new(src)

			// red mobs belong to the "red" group and the "spy" group
			vis.is_a(RED_MOB, SPY)
			walk_rand(src, 6)

	gray
		icon_state = "gray mob"

		New()
			..()
			vis = new(src)

			// gray mobs belong to the "gray" group and the "spy" group
			vis.is_a(GRAY_MOB, SPY)
			walk_rand(src, 10)

		// When you click on a gray mob, it leaves the "spy" group.
		// This lets you test two cases:
		//
		//   1. You can see both spies and gray mobs, so clicking
		//      on a gray mob won't change anything (you'll still
		//      be able to see it because you can see gray mobs).
		//   2. You can only see spies, so clicking on a gray mob
		//      will make it disappear.
		Click()
			vis.is_not_a(SPY)


atom
	icon = 'visibility-groups-icons.dmi'

turf
	icon_state = "grass"

	brick
		icon_state = "brick"
		density = 1